/* -------------------------------------------------------------------------- */
/*                               A List Apart                                 */
/*                              Style Switcher                                */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* Author: Paul Sowden                                                        */
/* Date: November 2, 2001                                                     */
/* URL: http://www.alistapart.com/stories/alternate/                          */
/* ALTERNATIVE STYLE, working with alternative style sheets                   */
/* Script Type: JavaScript                                                    */
/* -------------------------------------------------------------------------- */

function ALA_setActiveStyleSheet(title) {
	var i, a;
	for (i=0; (a = document.getElementsByTagName("link")[i]); i++) {
		if ( a.getAttribute("rel").indexOf("style") != -1 && a.getAttribute("title") ) {
			if ( a.getAttribute("title") == title ) a.disabled = false;
			else a.disabled = true;
		}
	}
}

function ALA_getActiveStyleSheet() {
	var i, a;
	var activeCSS = null;
	for (i=0; (a = document.getElementsByTagName("link")[i]); i++) {
		if ( a.getAttribute("rel").indexOf("style") != -1 && a.getAttribute("title") && !a.disabled )
			activeCSS = a.getAttribute("title");
	}
	return activeCSS;
}

function ALA_getPreferredStyleSheet() {
	var i, a;
	var preferredCSS = null;
	for (i=0; (a = document.getElementsByTagName("link")[i]); i++) {
    if ( a.getAttribute("rel").indexOf("style") != -1 &&
	     a.getAttribute("rel").indexOf("alt") == -1 &&
		 a.getAttribute("title") )
		preferredCSS = a.getAttribute("title");
	}
	return preferredCSS;
}

function ALA_createCookie(name,value,days) {
	if (days) {
    	var date = new Date();
	    date.setTime( date.getTime() + (days*24*60*60*1000) );
    	var expires = "; expires=" + date.toGMTString();
	}
	else
		expires = "";
	document.cookie = name + "=" + value + expires + "; path=/";
}

function ALA_readCookie(name) {
	var i = 0;
	var c = "";
	var cookieValue = null;
	var nameEQ = name + "=";
	var ca = document.cookie.split(';');
	for (i=0; i < ca.length; i++) {
	    c = ca[i];
    	while ( c.charAt(0)==' ' ) c = c.substring(1,c.length);
	    if ( c.indexOf(nameEQ) == 0 ) {
			cookieValue = c.substring(nameEQ.length,c.length);
			break;
		}
	}
	return cookieValue;
}

window.onload = function(e) {
	var cookie = ALA_readCookie("style");
	var title = cookie ? cookie : ALA_getPreferredStyleSheet();
	ALA_setActiveStyleSheet(title);
}

window.onunload = function(e) {
	var title = ALA_getActiveStyleSheet();
	ALA_createCookie("style", title, 365);
}

var cookie = ALA_readCookie("style");
var title = cookie ? cookie : ALA_getPreferredStyleSheet();
ALA_setActiveStyleSheet(title);
