/* -------------------------------------------------------------------------- */
/*                             JAVASCRIPT VISION                              */
/*                               Array Method                                 */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* Author: Gary S. Krajci                                                     */
/* Email: gary.s.krajci@bigfoot.com                                           */
/* Company: Roaring Fork Software                                             */
/* Date: May 29, 1999                                                         */
/* URL: http://www.roaringforksoftware.com/JSV/                               */
/* Script Type: JavaScript                                                    */
/* -------------------------------------------------------------------------- */

Array.prototype.subjoin = _subjoin;
function _subjoin(arg1, arg2, arg3) {
    return JSV_subjoin(this, arg1, arg2, arg3);
}

function JSV_subjoin(expA) {
	var joined = '';
	var aLength = expA.length;

	if (aLength == 1) {
		joined = expA[0];
	}
	else if (aLength > 1) {
		var i = 0, numberCount = 0;
		var argLength = JSV_subjoin.arguments.length;
		var start = 0, end = aLength, delimiter = ',';

		if (argLength > 1) {
			for (i=1; i<argLength; i++) {
				if (typeof JSV_subjoin.arguments[i] == "string") {
					delimiter = JSV_subjoin.arguments[i].charAt(0);
				}
				else if (typeof JSV_subjoin.arguments[i] == "number") {
					if (numberCount == 0) {
						start = JSV_subjoin.arguments[i];
						numberCount++;
					}
					else {
						end = JSV_subjoin.arguments[i];
						numberCount++;
					}
				}
			}
		}

		if (start > end) {
			var swap = start; start = end; end = swap;
		}
		
		var lastElement = end-1;
		for (i=start; i<end; i++) {
			joined = joined + expA[i] + ( (i != lastElement) ? delimiter : '' );
		}
	}
	return joined;
}
