/* -------------------------------------------------------------------------- */
/*                             JAVASCRIPT VISION                              */
/*                              Calendar Method                               */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* Author: Gary S. Krajci                                                     */
/* Email: gary.s.krajci@bigfoot.com                                           */
/* Company: Roaring Fork Software                                             */
/* Date: June 17, 2000                                                        */
/* URL: http://www.roaringforksoftware.com/JSV/                               */
/* Script Type: JavaScript                                                    */
/* -------------------------------------------------------------------------- */

Date.prototype.calendar = _calendar;
function _calendar() {
    return JSV_calendar(this);
}

function _tableAttributes(expT) {
	var attributes = '';
	if (expT != null) {
		var attributesArray = expT.split(':');
		var attributesLength = attributesArray.length;
		if (attributesLength >= 2 && attributesLength % 2 == 0) {
			var i = 0;
			for (i=0; i<attributesLength; i++) {
				if ( i % 2 == 0 )
					attributes = attributes + ' ' + attributesArray[i] + '=' + '\"';
				else
					attributes = attributes + attributesArray[i] + '\"';
			}
		}
	}
	return ( attributes.length == 0 ? ' border=\"1\"' : attributes );
}

function JSV_calendar(expD, expT) {
	var today = new Date();
	if (expD != null) today = expD;

	var tableAttributes = _tableAttributes(expT);

	var thisYear = JSV_getFullYear(expD),
		thisDay = expD.getDate(),
		thisMonth = expD.getMonth(),
		nDays = daysInMonth[thisMonth];

	if (thisMonth == 1) nDays += (JSV_isLeapYear(thisYear) ? 1 : 0);
	var internalDate = new Date(thisYear, thisMonth, 1);
	internalDate.setDate(1);
	var startDay = internalDate.getDay();

	document.write("<table" + tableAttributes + " CLASS=\"jsvCalendarTable\">");
	document.write("<tr class=\"jsvCalendarHeader\"><th colspan=\"7\">");
	document.write(JSV_cMonth(today));
	document.write(" ");
	document.write( thisYear );
	document.write("</th></tr>");
	document.write("<tr class=\"jsvCalendarDayHeader\"><th>Sun</th><th>Mon</th><th>Tue</th><th>Wed</th><th>Thu</th><th>Fri</th><th>Sat</th></tr>");
	document.write("<tr>");

	column = 0;
	for (i=0; i<startDay; i++) {
		document.write("<td class=\"jsvBlankCells\">&nbsp;</td>");
		column++;
	}

	for (i=1; i<=nDays; i++) {
		if (column == 0) document.write("<tr>");

		if (i == thisDay) {
			document.write("<td align=\"center\" class=\"jsvCurrentDay\">");
			document.write("<FONT COLOR=\"red\" class=\"jsvCurrentDay\">");
		}
		else
			document.write("<td align=\"center\" class=\"jsvCalendarDay\">");
		document.write(i);
		if (i == thisDay) document.write("</FONT>");
		document.write("</td>");

		column++;
		if (column == 7) {
			document.write("</tr>"); 
			if (i != nDays) column = 0;
		}
	}
	if (column != 7) {
		for (i=0; i<7-column; i++) document.write("<td class=\"jsvBlankCells\">&nbsp;</td>");
	}
	document.write("</tr></table>");
}
