/* -------------------------------------------------------------------------- */
/*                             JAVASCRIPT VISION                              */
/*                          Frame Management Methods                          */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* Author: Gary S. Krajci                                                     */
/* Email: gary.s.krajci@bigfoot.com                                           */
/* Company: Roaring Fork Software                                             */
/* Date: October 15, 1999                                                     */
/* URL: http://www.roaringforksoftware.com/JSV/                               */
/* Script Type: JavaScript                                                    */
/* -------------------------------------------------------------------------- */

var FRAMEDOESNOTEXIST = -1;
var CGIQUERYSTRING = window.location.search;

function JSV_isWebPageLocal() {
	return ( window.location.href.toLowerCase().substring(0,4) != "http" );
}

/* -------------------------------------------------------------------------- */
/*                               Frame Methods                                */
/* -------------------------------------------------------------------------- */

function JSV_getFrameReference(frameName) {
	var frameIndex = FRAMEDOESNOTEXIST;
	var numberOfFramesDefined = JSV_frameCount();
	if (numberOfFramesDefined > 0) {
		var i = 0;
		for (i=0; i<numberOfFramesDefined; i++) {
			if ( frameName.toLowerCase() == parent.frames[i].name.toLowerCase() ) {
				frameIndex = i;
				break;
			}
		}
	}
	return frameIndex;
}

function JSV_loadFrame(frameName, frameSetPage, replace) {
	var frameReference = JSV_getFrameReference(frameName);
	if ( frameReference != FRAMEDOESNOTEXIST ) {
		if ( JSV_isWhitespace(replace) ? false : replace )
			parent.frames[frameReference].location.replace(frameSetPage);
		else
			parent.frames[frameReference].location.href = frameSetPage;
	}
}

function JSV_doesFrameExist(frameName) {
	return ( (JSV_getFrameReference(frameName) == FRAMEDOESNOTEXIST) ? false : true );
}

function JSV_loadInFrame(replace) {
	var frameSetPage = JSV_getAttribute(CGIQUERYSTRING, "frameSetPage", false);
	var frameName = JSV_getAttribute(CGIQUERYSTRING, "frameName", false);
	
	if ( !JSV_isEmpty(frameSetPage) && !JSV_isEmpty(frameName) )
		JSV_loadFrame(frameName, frameSetPage, replace);
}

function JSV_localLoadInFrame(tempFile, replace) {
	if ( !JSV_isWhitespace(tempFile) ) {
		var frameSettings = JSV_readFrameSettings(tempFile);
		var frameSetPage = frameSettings.listGetAt(2,',');
		var frameName = frameSettings.listGetAt(1,',');

		if ( !JSV_isWhitespace(frameSetPage) && !JSV_isWhitespace(frameName) ) {
			JSV_loadFrame(frameName, frameSetPage, replace);
		}
	}
}

/* -------------------------------------------------------------------------- */
/*                           Frame Document Methods                           */
/* -------------------------------------------------------------------------- */

function JSV_frameDocumentWrite(frameName, info) {
	var frameReference = JSV_getFrameReference(frameName);
	if ( frameReference != FRAMEDOESNOTEXIST )
		parent.frames[frameReference].document.write(info);
}

function JSV_frameDocumentClose(frameName) {
	var frameReference = JSV_getFrameReference(frameName);
	if ( frameReference != FRAMEDOESNOTEXIST )
		parent.frames[frameReference].document.close();
}

/* -------------------------------------------------------------------------- */
/*                          Frame Management Utility                          */
/* -------------------------------------------------------------------------- */

var jsvFSW = null;

function _frameStatusText(frameIndex) {
	return	"Frame Name: " + parent.frames[frameIndex].name +
			JSV_br() +
			"Frame Index: " + frameIndex +
			JSV_br() +
			"URL: " + parent.frames[frameIndex].URL;
}

function JSV_showframeStatus(frameName) {
	var frameStatusText = '';
	var numberOfFramesDefined = JSV_frameCount();
	if (numberOfFramesDefined != 0) {
		if ( JSV_isWhitespace(frameName) ) {
			var i = 0;
			for (i=0; i<numberOfFramesDefined; i++) {
				frameStatusText =	frameStatusText +
									_frameStatusText(i);
			}
		}
		else {
			var frameIndex = JSV_getFrameReference(frameName);
			if (frameIndex != FRAMEDOESNOTEXIST)
				frameStatusText = _frameStatusText(frameIndex);
			else
				frameStatusText = "Frame '" + frameName + "' is not defined."
		}
	}
	else {
		frameStatusText = '<H1 ALIGN="center">There are no frames defined.</H1>';
	}

	jsvFSW = JSV_popWindow(	jsvFSW, 
							"FrameDefintion", 
							"", 
							"status=1,scrollbars=1,resizable=1,width=580,height=240,left=0,top=0,screenX=0,screenY=0",
							false );
	jsvFSW.document.write(	JSV_html( 
										JSV_head( JSV_title('JavaScript Vision Frame Status') ) + 
										JSV_body(frameStatusText)
										)
							);
	jsvFSW.document.close();
}
