/* -------------------------------------------------------------------------- */
/*                             JAVASCRIPT VISION                              */
/*                              String  Methods                               */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* Author: Gary S. Krajci                                                     */
/* Email: gary.s.krajci@bigfoot.com                                           */
/* Company: Roaring Fork Software                                             */
/* Date: April 20, 1999                                                       */
/* URL: http://www.roaringforksoftware.com/JSV/                               */
/* Script Type: JavaScript                                                    */
/* -------------------------------------------------------------------------- */

String.prototype.capitalize = _capitalize;
function _capitalize() {
	return JSV_capitalize(this);
}

function inDontCapitalizeList_(word, dca) {
	var j = 0;
	for (j=0; j<dca.length; j++) {
		if (word.toLowerCase() == dca[j].toLowerCase()) {
			word = dca[j];
			break;
		}
	}
	return word;
}

function JSV_capitalize() {
	var i = 0, j = 0, k = 0;
	var resetCase = false;
	var titleCase = false;
	var properNames = true;
	var capitalizeHyphenatedWords = false;
	var stringToCapitalize = JSV_capitalize.arguments[0];
	var dontCapitalizeList = ACP;
	var prepositionArray = ACP.split(",");
	
	for (i=1; i<JSV_capitalize.arguments.length; i++) {
		if (typeof JSV_capitalize.arguments[i] == "string")
			dontCapitalizeList = JSV_listAppend(dontCapitalizeList,JSV_capitalize.arguments[i],",");
		else if (JSV_capitalize.arguments[i] == RESETCASE)
			resetCase = true;
		else if (JSV_capitalize.arguments[i] == TITLECASE)
			var titleCase = true;
		else if (JSV_capitalize.arguments[i] == CAPITALIZEHYPHENATEDWORDS)
			var capitalizeHyphenatedWords = true;
	}

	var capitalizeRE = /[A-Z][A-Z]/;
	var capitalizedWord = ''
	var capitalizedString = '';
	var hyphenatedWordsArray = new Array();
	var capitalizeArray = stringToCapitalize.split(" ");

	for (i=0; i<capitalizeArray.length; i++) {
		capitalizedWord = capitalizeArray[i];

		if (resetCase)
			capitalizedWord = capitalizedWord.toLowerCase();
		else if ( capitalizeRE.test(capitalizedWord) )
			capitalizedWord = capitalizedWord.toLowerCase();

		capitalizedWord = JSV_capitalizeFirstCharacter(capitalizedWord);

		// --- Check for word existing in the dontCapitalizeList ---------------
		var dontCapitalizeArray = dontCapitalizeList.split(",");
		capitalizedWord = inDontCapitalizeList_(capitalizedWord, dontCapitalizeArray);

		// --- Check if hyphenated words are to be capitalized -----------------
		if (capitalizeHyphenatedWords && capitalizedWord.indexOf('-') != -1) {
			hyphenatedWordsArray = capitalizedWord.parseString('-');
			capitalizedWord = '';
			for (k=0; k<hyphenatedWordsArray.length; k++) {
				capitalizedWord +=
					inDontCapitalizeList_( JSV_capitalizeFirstCharacter(hyphenatedWordsArray[k]),dontCapitalizeArray );
			}
		}

		// --- Check if words are to be placed in title case -------------------
		if(titleCase) {
			if (i == 0 || i == capitalizeArray.length)
				capitalizedWord = JSV_capitalizeFirstCharacter(capitalizedWord);
			else {
				for (j=0; j<prepositionArray.length; j++) {
					if (capitalizedWord.toLowerCase() == prepositionArray[j].toLowerCase() && prepositionArray[j].length > 4) {
						capitalizedWord = JSV_capitalizeFirstCharacter(prepositionArray[j]);
						break;
					}
				}
			}
		}

		// --- Check if word may be a special proper name ----------------------
		if (properNames) {
			if (capitalizedWord.charAt(1) == "'") {
				// Names such as O'Malley, O'Brian and D'Amato
				capitalizedWord = nameCapitalization_(capitalizedWord, "'");
			}
			else if (capitalizedWord.substring(0,2).toLowerCase() == "mc") {
				// Names that begin with Mc such as McCoy
				capitalizedWord = nameCapitalization_(capitalizedWord, "mc");
			}
		}

		// --- All word to final string ----------------------------------------
		capitalizedString = JSV_listAppend(capitalizedString,capitalizedWord," ");
	}

	return capitalizedString;
}
